# Force set of install variables:
set (CMAKE_INSTALL_PREFIX "$ENV{TL_INSTALL}/" CACHE PATH "Where to install TerraLib?" FORCE)
set (CMAKE_INSTALL_RPATH "$ENV{TL_INSTALL}/lib" CACHE PATH "Where to install TerraLib libs?" FORCE)
set (GDAL_CONFIG "$ENV{TL_INSTALL}/3rdparty/gdal2/bin/gdal-config" CACHE PATH "Where to find Gdal2?" FORCE)
set (GDAL_INCLUDE_DIR "$ENV{TL_INSTALL}/3rdparty/gdal2/include" CACHE PATH "Where to find Gdal2?" FORCE)
set (GDAL_LIBRARY "$ENV{TL_INSTALL}/3rdparty/gdal2/lib/libgdal.so" CACHE PATH "Where to find Gdal2?" FORCE)
set (GDAL_LIBRARY_DIR "$ENV{TL_INSTALL}/3rdparty/gdal2/lib" CACHE PATH "Where to find Gdal2?" FORCE)
set (CMAKE_PREFIX_PATH "/usr;$ENV{TL_INSTALL}/3rdparty;$ENV{TL_INSTALL}/3rdparty/lib" CACHE PATH "Where to find libraries?" FORCE)

# Config RPath variables:
set (CMAKE_SKIP_BUILD_RPATH OFF CACHE BOOL "Skip build rpath?" FORCE)
set (CMAKE_BUILD_WITH_INSTALL_RPATH OFF CACHE BOOL "Build with install rpath?" FORCE)
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH ON CACHE BOOL "Rpath use link path?" FORCE)

# Turn off TerraLib CMake variables:
set (TERRALIB_DOXYGEN_ENABLED OFF CACHE BOOL "Use Doxygen?" FORCE)
set (TERRALIB_BUILD_EXAMPLES_ENABLED OFF CACHE BOOL "Build Examples?" FORCE)
set (TERRALIB_BUILD_UNITTEST_ENABLED OFF CACHE BOOL "Build Unittests?" FORCE)
set (TERRALIB_MOD_BINDING_PYTHON_ENABLED OFF CACHE BOOL "Build binding Python?" FORCE)
set (TERRALIB_MOD_BINDING_LUA_ENABLED OFF CACHE BOOL "Build binding Lua?" FORCE)
set (TERRALIB_MOD_BINDING_JAVA_ENABLED OFF CACHE BOOL "Build binding Java?" FORCE)

# Turn on TerraLib CMake variables:
set (TERRALIB_BUILD_AS_BUNDLE ON CACHE BOOL "Build As Bundle?" FORCE)
set (TERRALIB_MOD_EDIT_CORE_ENABLED ON CACHE BOOL "Build Edit?" FORCE)
set (TERRALIB_MOD_QT_PLUGINS_WTSS_ENABLED ON CACHE BOOL "Build Wtss-Cxx?" FORCE)
set (TERRALIB_QHELP_ENABLED ON CACHE BOOL "Build Qhelp?" FORCE)
set (TERRALIB_QTRANSLATION_ENABLED ON CACHE BOOL "Build Qtranslations?" FORCE)
set (TERRALIB_TRANSLATOR_ENABLED ON CACHE BOOL "Build Translator?" FORCE)

# Set the package type to be generated:
set (CPACK_BINARY_DEB ON CACHE BOOL "Generate DEB?" FORCE)
set (CPACK_BINARY_STGZ OFF CACHE BOOL "Generate STGZ?" FORCE)
set (CPACK_BINARY_TGZ OFF CACHE BOOL "Generate TGZ?" FORCE)
set (CPACK_BINARY_TZ OFF CACHE BOOL "Generate TZ?" FORCE)
set (CPACK_SOURCE_TBZ2 OFF CACHE BOOL "Generate TBZ2 Source?" FORCE)
set (CPACK_SOURCE_TGZ OFF CACHE BOOL "Generate TGZ  Source?" FORCE)
set (CPACK_SOURCE_TZ OFF CACHE BOOL "Generate TZ Source?" FORCE)
